<?php

namespace Drupal\bundle_override_node\Plugin\bundle_override\EntityTypes\node;

use Drupal\bundle_override\Manager\Objects\BundleOverrideObjectsInterface;
use Drupal\node\Entity\Node;

/**
 * Class NodeB.
 *
 * @package Drupal\bundle_override_node\Plugin\bundle_override\EntityTypes\node
 */
abstract class NodeB extends Node implements BundleOverrideObjectsInterface {

  /**
   * {@inheritdoc}
   */
  public static function getStaticEntityTypeId() {
    return 'node';
  }

  /**
   * {@inheritdoc}
   */
  public static function create(array $values = []) {
    $values += ['type' => static::getStaticBundle()];
    return static::getOverridedStorage()->create($values);
  }

  /**
   * {@inheritdoc}
   */
  public static function loadMultiple(array $ids = NULL) {
    return static::getOverridedStorage()->loadMultiple($ids);
  }

  /**
   * Return the storage instance.
   *
   * @return NodeBStorage
   *   The storage entity.
   */
  private static function getOverridedStorage() {
    $entity_type = \Drupal::entityTypeManager()->getDefinition('node');
    $entity_type->destinationClass = get_called_class();
    return NodeBStorage::createInstance(\Drupal::getContainer(), $entity_type);
  }

}
