<?php

namespace Drupal\bundle_override_term\Plugin\bundle_override\EntityTypes\taxonomy_term;

use Drupal\bundle_override\Manager\Objects\BundleOverrideObjectsInterface;
use Drupal\taxonomy\Entity\Term;

/**
 * Class TermB.
 *
 * @package Drupal\bundle_override_term\Plugin\bundle_override\EntityTypes\taxonomy_term
 */
abstract class TermB extends Term implements BundleOverrideObjectsInterface {

  /**
   * {@inheritdoc}
   */
  public static function getStaticEntityTypeId() {
    return 'taxonomy_term';

  }

  /**
   * {@inheritdoc}
   */
  public static function create(array $values = []) {
    $values += ['type' => static::getStaticBundle()];
    return static::getOverridedStorage()->create($values);
  }

  /**
   * {@inheritdoc}
   */
  public static function loadMultiple(array $ids = NULL) {
    return static::getOverridedStorage()->loadMultiple($ids);
  }

  /**
   * Return the TermBStorage.
   *
   * @return TermBStorage
   *   The TermBStorage.
   */
  private static function getOverridedStorage() {
    $entity_type = \Drupal::entityTypeManager()->getDefinition('taxonomy_term');
    $entity_type->destinationClass = get_called_class();
    return TermBStorage::createInstance(\Drupal::getContainer(), $entity_type);
  }

}
