<?php

namespace Drupal\bundle_override_user\Plugin\bundle_override\EntityTypes\user;

use Drupal\bundle_override\Manager\Objects\BundleOverrideObjectsInterface;
use Drupal\user_bundle\Entity\TypedUser;

/**
 * Class UserB.
 *
 * @package Drupal\bundle_override_user\Plugin\bundle_override\EntityTypes\user
 */
abstract class UserB extends TypedUser implements BundleOverrideObjectsInterface {

  /**
   * {@inheritdoc}
   */
  public static function getStaticEntityTypeId() {
    return 'user';
  }

  /**
   * {@inheritdoc}
   */
  public static function create(array $values = []) {
    $values += ['type' => static::getStaticBundle()];
    return static::getOverridedStorage()->create($values);
  }

  /**
   * {@inheritdoc}
   */
  public static function loadMultiple(array $ids = NULL) {
    return static::getOverridedStorage()->loadMultiple($ids);
  }

  /**
   * Return the storage instance.
   *
   * @return UserBStorage
   *   The storage entity.
   */
  private static function getOverridedStorage() {
    $entity_type = \Drupal::entityTypeManager()->getDefinition('user');
    $entity_type->destinationClass = get_called_class();
    return UserBStorage::createInstance(\Drupal::getContainer(), $entity_type);
  }

}
